
// West Islip Engineering Technology Department
// Original Version 2.0  R Weber
//Sorting Tower Operation Sketch
//June 8 2022

#include <Stepper.h>

//****************** ENTER VALUES HERE ***********************
//**********************************************************************
//Enter the LOW and HIGH Values from your calibration worksheet
// making sure that each value has a semi-colon after it.

int RedLow = 30;
int RedHigh = 35;

int BlueLow = 30;
int BlueHigh = 38;

int GreenLow = 50;
int GreenHigh = 58;

//**********************************************************************
//After the values have been changed
// Save your code then UPLOAD your code to the sorting unit
//**********************************************************************
//**********************************************************************


const int stepsPerRevolution = 500;  // change this to fit the number of steps per revolution

// Pins entered in sequence IN1-IN3-IN2-IN4 for proper step sequence
Stepper myStepper = Stepper(stepsPerRevolution, 8, 10, 9, 11);

//for LED on unit
int LEDwhite = 0;
int LEDred = 3;
int LEDblue = 13;
int LEDgreen = 2;

// Define color sensor pins
#define S0 4
#define S1 5
#define S2 6
#define S3 7          
#define sensorOut 12

// Variables for Color Pulse Width Measurements
int redPW = 0;
int greenPW = 0;
int bluePW = 0;


void setup() {
  //LED setup
  pinMode(LEDwhite, OUTPUT);
  pinMode(LEDred, OUTPUT);
  pinMode(LEDgreen, OUTPUT);
  pinMode(LEDblue, OUTPUT);
    
    // Set S0 - S3 as outputs
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);

  // Set Pulse Width scaling to 20%
  digitalWrite(S0,HIGH);
  digitalWrite(S1,LOW);

  // Set Sensor output as input
  pinMode(sensorOut, INPUT);
  
  // set the speed at 60 rpm:
  myStepper.setSpeed(60);

}

void loop() {

  // Read Red Pulse Width
    redPW = getRedPW();
  // Delay to stabilize sensor
    delay(200);

  // Read Green Pulse Width
    greenPW = getGreenPW();
  // Delay to stabilize sensor
  delay(200);

  // Read Blue Pulse Width
    bluePW = getBluePW();
  // Delay to stabilize sensor
    delay(200);
    
//Clear ALL LEDs
  digitalWrite(LEDwhite,LOW);  
  digitalWrite(LEDred,LOW);
  digitalWrite(LEDgreen,LOW);
  digitalWrite(LEDblue,LOW);
  

  if (redPW > RedLow && redPW < RedHigh) // Evaluate Red Color
  {
    //Turn On RED LED
    digitalWrite(LEDred,HIGH);
    
      myStepper.step(-stepsPerRevolution);
  myStepper.step(-stepsPerRevolution);
  myStepper.step(-stepsPerRevolution);
      //delay(500);
      myStepper.step(stepsPerRevolution);
       myStepper.step(stepsPerRevolution);
       myStepper.step(stepsPerRevolution);
      //delay(500);
     
  } 
  else if (bluePW > BlueLow && bluePW < BlueHigh)
  {
  //Turn ON Blue LED
  digitalWrite(LEDblue,HIGH);
  
        myStepper.step(stepsPerRevolution);
        myStepper.step(stepsPerRevolution);
        myStepper.step(stepsPerRevolution);
        //delay(300);
        myStepper.step(-stepsPerRevolution);
        myStepper.step(-stepsPerRevolution);
        myStepper.step(-stepsPerRevolution);
    
  }
  
 else if (greenPW > GreenLow && greenPW < GreenHigh)
  {
     //Turn on Green LED and Buzzer
     digitalWrite(LEDgreen,HIGH); 
      delay(500);  
  }

  
  else
  {
     digitalWrite(LEDwhite,HIGH);


  }
}

// Function to read Red Pulse Widths
int getRedPW() {
  // Set sensor to read Red only
  digitalWrite(S2,LOW);
  digitalWrite(S3,LOW);
  // Define integer to represent Pulse Width
  int PW;
  // Read the output Pulse Width
  PW = pulseIn(sensorOut, LOW);
  // Return the value
  return PW;
}

// Function to read Green Pulse Widths
int getGreenPW() {
  // Set sensor to read Green only
  digitalWrite(S2,HIGH);
  digitalWrite(S3,HIGH);
  // Define integer to represent Pulse Width
  int PW;
  // Read the output Pulse Width
  PW = pulseIn(sensorOut, LOW);
  // Return the value
  return PW;
}

// Function to read Blue Pulse Widths
int getBluePW() {
  // Set sensor to read Blue only
  digitalWrite(S2,LOW);
  digitalWrite(S3,HIGH);
  // Define integer to represent Pulse Width
  int PW;
  // Read the output Pulse Width
  PW = pulseIn(sensorOut, LOW);
  // Return the value
  return PW;
}
